#!/usr/bin/env python3
#-------------------------------------------------------------
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#-------------------------------------------------------------

from __future__ import print_function
import os
import sys
import platform

try:
    exec(open('systemds/project_info.py').read())
except IOError:
    print("Could not read project_info.py.", file=sys.stderr)
    sys.exit()
ARTIFACT_NAME = __project_artifact_id__
ARTIFACT_VERSION = __project_version__
ARTIFACT_VERSION_SHORT = ARTIFACT_VERSION.split("-")[0]

root_dir = os.path.dirname(os.path.dirname(os.path.dirname(os.getcwd())))
src_path_prefix = os.path.join(root_dir, 'src', 'main', 'python', 'dist', ARTIFACT_NAME + '-' + ARTIFACT_VERSION_SHORT)
src_path = src_path_prefix + '.zip' if platform.system() == "Windows" and os.path.exists(
    src_path_prefix + '.zip') else src_path_prefix + '.tar.gz'
os.rename(
    src_path,
    os.path.join(root_dir, 'target', ARTIFACT_NAME + '-' + ARTIFACT_VERSION + '-python.tar.gz'))
wheel_name = '-'.join([ARTIFACT_NAME, ARTIFACT_VERSION_SHORT, 'py3', 'none', 'any.whl'])
wheel = os.path.join(root_dir, 'src', 'main', 'python', 'dist', wheel_name)
os.rename(wheel, os.path.join(root_dir, 'target', wheel_name))
